CF:374A - Inna and Pink Pony(思想题)

2024-06-08 23:58
文章标签 思想 cf pink inna pony 374a

本文主要是介绍CF:374A - Inna and Pink Pony(思想题),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Dima and Inna are doing so great! At the moment, Inna is sitting on the magic lawn playing with a pink pony. Dima wanted to play too. He brought an n × m chessboard, a very tasty candy and two numbers a and b.

Dima put the chessboard in front of Inna and placed the candy in position (i, j) on the board. The boy said he would give the candy if it reaches one of the corner cells of the board. He's got one more condition. There can only be actions of the following types:

  • move the candy from position (x, y) on the board to position (x - a, y - b);
  • move the candy from position (x, y) on the board to position (x + a, y - b);
  • move the candy from position (x, y) on the board to position (x - a, y + b);
  • move the candy from position (x, y) on the board to position (x + a, y + b).

Naturally, Dima doesn't allow to move the candy beyond the chessboard borders.

Inna and the pony started shifting the candy around the board. They wonder what is the minimum number of allowed actions that they need to perform to move the candy from the initial position (i, j) to one of the chessboard corners. Help them cope with the task!

Input

The first line of the input contains six integers n, m, i, j, a, b (1 ≤ n, m ≤ 106; 1 ≤ i ≤ n; 1 ≤ j ≤ m; 1 ≤ a, b ≤ 106).

You can assume that the chessboard rows are numbered from 1 to n from top to bottom and the columns are numbered from 1 to m from left to right. Position (i, j) in the statement is a chessboard cell on the intersection of the i-th row and the j-th column. You can consider that the corners are: (1, m)(n, 1)(n, m)(1, 1).

Output

In a single line print a single integer — the minimum number of moves needed to get the candy.

If Inna and the pony cannot get the candy playing by Dima's rules, print on a single line "Poor Inna and pony!" without the quotes.

Sample test(s)
input
5 7 1 3 2 2
output
2
input
5 5 2 3 1 1
output
Poor Inna and pony!
Note

Note to sample 1:

Inna and the pony can move the candy to position (1 + 2, 3 + 2) = (3, 5), from there they can move it to positions (3 - 2, 5 + 2) = (1, 7) and (3 + 2, 5 + 2) = (5, 7). These positions correspond to the corner squares of the chess board. Thus, the answer to the test sample equals two.


思路:唉 昨天做题的时候想成了BFS,然后直接T了,确实,数据都达到10^6了,不BFS不T才怪呢……实在是不该啊……刚才又想了一下,唉……真是思想题……

输入n,m,i,j,a,b。有图去考虑的话就知道是思想题了。因为如果那点左上方、右下方、右上方、左下方其与边界横坐标、纵坐标的距离如果都可以整除a,b的话,那说明这肯定可以达到其边界的其中一个顶点的……唉,这想想就简单了好多……可能是上周因为专攻BFS,所以就一直想用BFS,怎么都不想了,结果T了之后,才明白不能乱来啊,还以为这次比赛很难呢,其实是自己练得太少了。思想题真得多练练了……

#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<string>
#include<cmath>
#include<set>
#include<map>
#include<queue>
#include<vector>
#include<stack>
#include<ctime>
#include<cstdlib>
#define mem(a,b) memset(a,b,sizeof(a))
#define M 1000005
typedef long long ll;
using namespace std;
int n,m,i,j,a,b,ans=1<<30;
int abc(int x,int y)
{int x1=x%a;int y1=y%b;  if(!x1&&!y1)   //如果都整除{int p=abs(x/a-y/b);   //并且其次数之差为偶数才行if(!(p&1)) return min(max(x/a,y/b),ans);   //因为次数不相等的话,那大的那个得先变为与次数小的一样才行,变的过程借助a或者b,故偶数时才得正常转化}return ans;
}
int main()
{cin>>n>>m>>i>>j>>a>>b;if(i==1&&j==1||i==n&&j==1||i==1&&j==m||i==n&&j==m)printf("0\n");else{if(i-1>0&&j-1>0) ans=abc(i-1,j-1);if(i-1>0&&m-j>0) ans=abc(i-1,m-j);  //如果不在边界正常判断,调用判断函数if(n-i>0&&j-1>0) ans=abc(n-i,j-1);if(n-i>0&&m-j>0) ans=abc(n-i,m-j);if((i+a<=n&&i==1&&!((j-1)%b)||n-a>0&&i==n&&!((j-1)%b))&&((j-1)/b)%2==0) ans=min((j-1)/b,ans);  //如果在边界可以直接判断,符合的话,次数会更少if((i+a<=n&&i==1&&!((m-j)%b)||n-a>0&&i==n&&!((m-j)%b))&&((m-j)/b)%2==0) ans=min((m-j)/b,ans);  //但是在边界因为要借助a或者bif((j+b<=m&&j==1&&!((i-1)%a)||m-b>0&&j==m&&!((i-1)%a))&&((i-1)/a)%2==0) ans=min((i-1)/a,ans);  //所以需要判断i+a,n-i,j+b,m-j不能超过边界if((j+b<=m&&j==1&&!((n-i)%a)||m-b>0&&j==m&&!((n-i)%a))&&((n-i)/a)%2==0) ans=min((n-i)/a,ans);if(ans==(1<<30)) printf("Poor Inna and pony!\n");else printf("%d\n",ans);}return 0;
}
下面是比赛的时候写的BFS解法:超时了,哈哈

#include<iostream>  
#include<cstdio>  
#include<algorithm>  
#include<cstring>  
#include<string>  
#include<cmath>  
#include<set>  
#include<map>  
#include<queue>  
#include<vector>  
#include<stack>  
#include<ctime>  
#include<cstdlib>  
#define mem(a,b) memset(a,b,sizeof(a))  
#define M 1000005  
typedef long long ll;  
using namespace std;  
int n,m,i,j,a,b;   
struct abc  
{  int x,y,t;  
};  
queue<abc>q;  
multimap<int,int>w;  
multimap<int,int>::iterator it;  
int bfs()  
{  abc p;  p.x=i;  p.y=j;  p.t=0;  q.push(p);  while(!q.empty())  {  abc ans,tem;  ans=q.front();  q.pop();  if(ans.x==1&&ans.y==m||ans.x==1&&ans.y==1||ans.x==n&&ans.y==1||ans.x==n&&ans.y==m)  return ans.t;  int a1,b1;  for(int i=0; i<4; i++)  {  if(i==0)  {  a1=-a;  b1=-b;  }  else if(i==1)  {  a1=-a;  b1=b;  }  else if(i==2)  {  a1=a;  b1=-b;  }  else  {  a1=a;  b1=b;  }  tem.x=ans.x+a1;  tem.y=ans.y+b1;  if(tem.x>=1&&tem.y>=1&&tem.x<=n&&tem.y<=m)  {  it=w.find(tem.x);  if(it==w.end()||it->second!=tem.y)  {  tem.t=ans.t+1;  q.push(tem);  pair<int,int> p1(tem.x,tem.y);  w.insert(p1);  }  }  if(tem.x==1&&tem.y==m||tem.x==1&&tem.y==1||tem.x==n&&tem.y==1||tem.x==n&&tem.y==m)  return tem.t;  }  }  return -1;  
}  
int main()  
{  cin>>n>>m>>i>>j>>a>>b;  int sum=bfs();  if(sum==-1) printf("Poor Inna and pony!\n");  else printf("%d\n",sum);  return 0;  
} 



这篇关于CF:374A - Inna and Pink Pony(思想题)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1043677

相关文章

hdu1496(用hash思想统计数目)

作为一个刚学hash的孩子,感觉这道题目很不错,灵活的运用的数组的下标。 解题步骤:如果用常规方法解,那么时间复杂度为O(n^4),肯定会超时,然后参考了网上的解题方法,将等式分成两个部分,a*x1^2+b*x2^2和c*x3^2+d*x4^2, 各自作为数组的下标,如果两部分相加为0,则满足等式; 代码如下: #include<iostream>#include<algorithm

cf 164 C 费用流

给你n个任务,k个机器,n个任务的起始时间,持续时间,完成任务的获利 每个机器可以完成任何一项任务,但是同一时刻只能完成一项任务,一旦某台机器在完成某项任务时,直到任务结束,这台机器都不能去做其他任务 最后问你当获利最大时,应该安排那些机器工作,即输出方案 具体建图方法: 新建源汇S T‘ 对任务按照起始时间s按升序排序 拆点: u 向 u'连一条边 容量为 1 费用为 -c,

CF 508C

点击打开链接 import java.util.Arrays;import java.util.Scanner;public class Main {public static void main(String [] args){new Solve().run() ;} }class Solve{int bit[] = new int[608] ;int l

函数式编程思想

我们经常会用到各种各样的编程思想,例如面向过程、面向对象。不过笔者在该博客简单介绍一下函数式编程思想. 如果对函数式编程思想进行概括,就是f(x) = na(x) , y=uf(x)…至于其他的编程思想,可能是y=a(x)+b(x)+c(x)…,也有可能是y=f(x)=f(x)/a + f(x)/b+f(x)/c… 面向过程的指令式编程 面向过程,简单理解就是y=a(x)+b(x)+c(x)

实例demo理解面向接口思想

浅显的理解面向接口编程 Android开发的语言是java,至少目前是,所以理解面向接口的思想是有必要的。下面通过一个简单的例子来理解。具体的概括我也不知道怎么说。 例子: 现在我们要开发一个应用,模拟移动存储设备的读写,即计算机与U盘、MP3、移动硬盘等设备进行数据交换。已知要实现U盘、MP3播放器、移动硬盘三种移动存储设备,要求计算机能同这三种设备进行数据交换,并且以后可能会有新的第三方的

【CF】C. Glass Carving(二分 + 树状数组 + 优先队列 + 数组计数)

这题简直蛋疼死。。。。。 A了一下午 #include<cstdio>#include<queue>#include<cstring>#include<algorithm>using namespace std;typedef long long LL;const int maxn = 200005;int h,w,n;int C1[maxn],C2[maxn];int

【CF】E. Anya and Cubes(双向DFS)

根据题意的话每次递归分3种情况 一共最多25个数,时间复杂度为3^25,太大了 我们可以分2次求解第一次求一半的结果,也就是25/2 = 12,记录结果 之后利用剩余的一半求结果 s-结果 = 之前记录过的结果 就可以 时间复杂度降低为 3 ^ (n/2+1) 题目链接:http://codeforces.com/contest/525/problem/E #include<set

【CF】D. Arthur and Walls(BFS + 贪心)

D题 解题思路就是每次检查2X2的方格里是否只有一个‘*’,如果有的话这个*就需要变成‘.’,利用BFS进行遍历,入队的要求是这个点为. 一开始将所有的'.'全部加入队列,如果碰到一个'*'变成'.'就入队,判断的时候从4个方向就行判断 题目链接:http://codeforces.com/contest/525/problem/D #include<cstdio>#include<

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF Bayan 2015 Contest Warm Up B.(dfs+暴力)

B. Strongly Connected City time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/475/probl